//+------------------------------------------------------------------+
//|                                       profit_gauge_indicator.mq5 |
//|                                         Copyright 2015, Decanium |
//|                                         https://www.decanium.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Decanium"
#property link      "https://www.decanium.com"
#property version   "1.00"
#property indicator_plots 0
#property indicator_chart_window

#include <Gauge\gauge_graph.mqh>

input int inp_scale_range=270;   //  , 30..320 
input int inp_rotation=45;       //  , 0..359 
input string inp_gauge_name="gg01"; //  
input int inp_x = 40;   //   
input int inp_y = 40;   //   
input int inp_size=300; //  
input string inp_ObjRel=""; //      
input ENUM_REL_MODE inp_rel_mode=RELATIVE_MODE_NONE; //   
input ENUM_BASE_CORNER inp_corner=CORNER_LEFT_UPPER; //  
input bool inp_back=false; //    
input uchar inp_scale_transparency=0; //   , 0..255
input uchar inp_needle_transparency=0; //   , 0..255

//---    
GAUGE_STR g0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   if(GaugeCreate(inp_gauge_name,g0,inp_x,inp_y,inp_size,inp_ObjRel,inp_rel_mode,
      inp_corner,inp_back,inp_scale_transparency,inp_needle_transparency)==false)
      return(INIT_FAILED);
//---       
   GaugeSetScaleParameters(g0,inp_scale_range,inp_rotation,-200,400,MUL_1,SCALE_INNER,clrBlack);
   GaugeSetMarkParameters(g0,MARKS_INNER,SIZE_MIDDLE,100,1,4);
//---    
   GaugeSetRangeParameters(g0,0,true,200,400,clrLimeGreen);
   GaugeSetRangeParameters(g0,1,true,-100,-200,clrCoral);
//---   
   GaugeSetLegendParameters(g0,LEGEND_DESCRIPTION,true,"Profit",3,0,14,"Arial",false,false);
   GaugeSetLegendParameters(g0,LEGEND_UNITS,true,"USD",8,215,10,"Arial",true,false);
   GaugeSetLegendParameters(g0,LEGEND_VALUE,true,"1",4,225,20,"Arial",true,false);
//---   
   GaugeRedraw(g0);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---   
   GaugeDelete(g0);
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---  
   double profit=AccountInfoDouble(ACCOUNT_PROFIT);
   GaugeNewValue(g0,profit);
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---        
   if(id==CHARTEVENT_CHART_CHANGE && inp_rel_mode!=RELATIVE_MODE_NONE)
     {
      if(GaugeCalcLocation(g0)==true)
         GaugeRelocation(g0);
     }
  }
//+------------------------------------------------------------------+
